package com.javahonk;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.AbstractApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * @author Java Honk
 *
 */
public class CronQuartzJobTestApp {
	
	private static final Logger LOGGER = LogManager.getLogger(CronQuartzJobTestApp.class.getName());
	
	public static void main(String[] args) {
		
		LOGGER.info("Application starting...");	
		
		ApplicationContext context = new ClassPathXmlApplicationContext("spring-context.xml");
		
		registerShutdownHook(context);
	}
	
	private static void registerShutdownHook(ApplicationContext context) {
		
		Runtime.getRuntime().addShutdownHook(new Thread(new Runnable() {

			@Override
			public void run() {
				LOGGER.info("LifeCycleManagerApp Exiting.");
				((AbstractApplicationContext) context).close();

			}
		}));
	}
	
}
